From 0fac32193904fdd75dcff71e5e4bd846b6e560b7 Mon Sep 17 00:00:00 2001
From: Adrian Taylor <adetaylor@chromium.org>
Date: Oct 26 2020 22:17:02 +0000
Subject: [PATCH 1064/2232] Adding tests for method calls in foreign namespaces


---

diff --git a/tests/BUCK b/tests/BUCK
index 5bbe500..f51be09 100644
--- a/tests/BUCK
+++ b/tests/BUCK
@@ -15,6 +15,7 @@ rust_library(
         "ffi/extra.rs",
         "ffi/lib.rs",
         "ffi/module.rs",
+        "ffi/class_in_ns.rs",
     ],
     crate = "cxx_test_suite",
     deps = [
@@ -30,6 +31,7 @@ cxx_library(
         ":bridge/source",
         ":extra/source",
         ":module/source",
+        ":class_in_ns/source",
     ],
     headers = {
         "ffi/lib.rs.h": ":bridge/header",
@@ -52,3 +54,8 @@ rust_cxx_bridge(
     name = "module",
     src = "ffi/module.rs",
 )
+
+rust_cxx_bridge(
+    name = "class_in_ns",
+    src = "ffi/class_in_ns.rs",
+)
diff --git a/tests/BUILD b/tests/BUILD
index 57ffab9..a400f47 100644
--- a/tests/BUILD
+++ b/tests/BUILD
@@ -18,6 +18,7 @@ rust_library(
         "ffi/extra.rs",
         "ffi/lib.rs",
         "ffi/module.rs",
+        "ffi/class_in_ns.rs",
     ],
     deps = [
         ":impl",
@@ -32,6 +33,7 @@ cc_library(
         ":bridge/source",
         ":extra/source",
         ":module/source",
+        ":class_in_ns/source",
     ],
     hdrs = ["ffi/tests.h"],
     deps = [
@@ -57,3 +59,9 @@ rust_cxx_bridge(
     src = "ffi/module.rs",
     deps = [":impl"],
 )
+
+rust_cxx_bridge(
+    name = "class_in_ns",
+    src = "ffi/class_in_ns.rs",
+    deps = [":impl"],
+)
\ No newline at end of file
diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
index 4b2cbdf..9bdb711 100644
--- a/tests/ffi/build.rs
+++ b/tests/ffi/build.rs
@@ -6,7 +6,7 @@ fn main() {
     }
 
     CFG.include_prefix = "tests/ffi";
-    let sources = vec!["lib.rs", "extra.rs", "module.rs"];
+    let sources = vec!["lib.rs", "extra.rs", "module.rs", "class_in_ns.rs"];
     cxx_build::bridges(sources)
         .file("tests.cc")
         .flag_if_supported(cxxbridge_flags::STD)
diff --git a/tests/ffi/class_in_ns.rs b/tests/ffi/class_in_ns.rs
new file mode 100644
index 0000000..8b50561
--- /dev/null
+++ b/tests/ffi/class_in_ns.rs
@@ -0,0 +1,21 @@
+// To test receivers on a type in a namespace outide
+// the default. cxx::bridge blocks can only have a single
+// receiver type, and there can only be one such block per,
+// which is why this is outside.
+
+#[rustfmt::skip]
+#[cxx::bridge(namespace = tests)]
+pub mod ffi3 {
+
+    extern "C" {
+        include!("tests/ffi/tests.h");
+
+        #[namespace (namespace = I)]
+        type I;
+
+        fn get(self: &I) -> u32;
+
+        #[namespace (namespace = I)]
+        fn ns_c_return_unique_ptr_ns() -> UniquePtr<I>;
+    }
+}
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index a491ae2..be145f3 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -4,6 +4,7 @@
     clippy::trivially_copy_pass_by_ref
 )]
 
+pub mod class_in_ns;
 pub mod extra;
 pub mod module;
 
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 1f0f8ff..05bf5fb 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -647,4 +647,14 @@ namespace other {
       cxx_test_suite_set_correct();
     }
   }
-}
\ No newline at end of file
+} // namespace other
+
+namespace I {
+  uint32_t I::get() const {
+    return a;
+  }
+
+  std::unique_ptr<I> ns_c_return_unique_ptr_ns() {
+    return std::unique_ptr<I>(new I());
+  }
+} // namespace I
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 40bc802..3835660 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -182,4 +182,16 @@ namespace other {
   void ns_c_take_trivial(::tests::D d);
   ::tests::D ns_c_return_trivial();
   void ns_c_take_ns_shared(::A::AShared shared);
-} // namespace other
\ No newline at end of file
+} // namespace other
+
+namespace I {
+  class I {
+  private:
+    uint32_t a;
+  public:
+    I() : a(1000) {}
+    uint32_t get() const;
+  };
+
+  std::unique_ptr<I> ns_c_return_unique_ptr_ns();
+} // namespace I
diff --git a/tests/test.rs b/tests/test.rs
index 21f8a8c..20b23ac 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -1,3 +1,4 @@
+use cxx_test_suite::class_in_ns::ffi3;
 use cxx_test_suite::extra::ffi2;
 use cxx_test_suite::ffi;
 use std::cell::Cell;
@@ -194,6 +195,14 @@ fn test_c_method_calls() {
 }
 
 #[test]
+fn test_c_ns_method_calls() {
+    let unique_ptr = ffi3::ns_c_return_unique_ptr_ns();
+
+    let old_value = unique_ptr.get();
+    assert_eq!(1000, old_value);
+}
+
+#[test]
 fn test_enum_representations() {
     assert_eq!(0, ffi::Enum::AVal.repr);
     assert_eq!(2020, ffi::Enum::BVal.repr);

